/*

*/

package tokenizer;

/**
   An instance of this class represents one token.
   <p>
   Each {@code Token} remembers its line number and
   its starting position in that line within the
   original {@link String} from the language being
   parsed.
*/
public class Token
{
   public final String lexeme;   // the text of the token
   public final int    line;     // line number
   public final int    position; // starting position of this token

   /**
      @param lexeme    the {@link String} token itself
      @param line      the line number the token comes from
      @param position  the token's starting position in the line
   */
   public Token(final String lexeme, final int line, final int position)
   {
      this.lexeme = lexeme;
      this.line = line;
      this.position = position;
   }

   @Override
   public String toString()
   {
      return "<'" + lexeme + "', " + line + ", " + position + ">";
   }
}
